# coding: utf-8

"""


    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ...base_api import BaseApi
from ...configuration import Configuration
from ..api_client import ApiClient


class PollsubmissionsApi(BaseApi):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    # OPERATIONID: create_single_poll_submission
    def create_single_poll_submission(self, poll_id, poll_session_id, poll_submissions_poll_choice_id, **kwargs):
        """
        Create a single poll submission
        Create a new poll submission for this poll session

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_single_poll_submission_with_http_info(poll_id, poll_session_id, poll_submissions_poll_choice_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str poll_id: ID (required)
        :param str poll_session_id: ID (required)
        :param list[int] poll_submissions_poll_choice_id: The chosen poll choice for this submission. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['poll_id', 'poll_session_id', 'poll_submissions_poll_choice_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('per_page')
        all_params.append('page')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_single_poll_submission" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'poll_id' is set
        if ('poll_id' not in params) or (params['poll_id'] is None):
            raise ValueError("Missing the required parameter `poll_id` when calling `create_single_poll_submission`")
        # verify the required parameter 'poll_session_id' is set
        if ('poll_session_id' not in params) or (params['poll_session_id'] is None):
            raise ValueError("Missing the required parameter `poll_session_id` when calling `create_single_poll_submission`")
        # verify the required parameter 'poll_submissions_poll_choice_id' is set
        if ('poll_submissions_poll_choice_id' not in params) or (params['poll_submissions_poll_choice_id'] is None):
            raise ValueError("Missing the required parameter `poll_submissions_poll_choice_id` when calling `create_single_poll_submission`")

        resource_path = '/v1/polls/{poll_id}/poll_sessions/{poll_session_id}/poll_submissions'.replace('{format}', 'json')
        path_params = {}
        if 'poll_id' in params:
            path_params['poll_id'] = params['poll_id']
        if 'poll_session_id' in params:
            path_params['poll_session_id'] = params['poll_session_id']

        query_params = {}
        if 'per_page' in params:
            query_params['per_page'] = params['per_page']
        if 'page' in params:
            query_params['page'] = params['page']

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'poll_submissions_poll_choice_id' in params:
            form_params.append(('poll_submissions[poll_choice_id]', params['poll_submissions_poll_choice_id']))

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['canvas']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    # OPERATIONID: get_single_poll_submission
    def get_single_poll_submission(self, poll_id, poll_session_id, id, **kwargs):
        """
        Get a single poll submission
        Returns the poll submission with the given id

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_single_poll_submission_with_http_info(poll_id, poll_session_id, id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str poll_id: ID (required)
        :param str poll_session_id: ID (required)
        :param str id: ID (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['poll_id', 'poll_session_id', 'id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('per_page')
        all_params.append('page')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_single_poll_submission" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'poll_id' is set
        if ('poll_id' not in params) or (params['poll_id'] is None):
            raise ValueError("Missing the required parameter `poll_id` when calling `get_single_poll_submission`")
        # verify the required parameter 'poll_session_id' is set
        if ('poll_session_id' not in params) or (params['poll_session_id'] is None):
            raise ValueError("Missing the required parameter `poll_session_id` when calling `get_single_poll_submission`")
        # verify the required parameter 'id' is set
        if ('id' not in params) or (params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_single_poll_submission`")

        resource_path = '/v1/polls/{poll_id}/poll_sessions/{poll_session_id}/poll_submissions/{id}'.replace('{format}', 'json')
        path_params = {}
        if 'poll_id' in params:
            path_params['poll_id'] = params['poll_id']
        if 'poll_session_id' in params:
            path_params['poll_session_id'] = params['poll_session_id']
        if 'id' in params:
            path_params['id'] = params['id']

        query_params = {}
        if 'per_page' in params:
            query_params['per_page'] = params['per_page']
        if 'page' in params:
            query_params['page'] = params['page']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type([])

        # Authentication setting
        auth_settings = ['canvas']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
